--- emacs24-24.3+1.orig/lisp/progmodes/cc-langs.el
+++ emacs24-24.3+1/lisp/progmodes/cc-langs.el
@@ -2290,13 +2301,12 @@ This construct is \"<keyword> <expressio
 
 (c-lang-defconst c-constant-kwds
   "Keywords for constants."
-  t       nil
+  t	  nil
   (c c++) '("NULL" ;; Not a keyword, but practically works as one.
 	    "false" "true")		; Defined in C99.
-  objc    '("nil" "Nil" "YES" "NO" "NS_DURING" "NS_HANDLER" "NS_ENDHANDLER")
-  idl     '("TRUE" "FALSE")
-  java    '("true" "false" "null") ; technically "literals", not keywords
-  pike    '("UNDEFINED")) ;; Not a keyword, but practically works as one.
+  objc	  '("nil" "Nil" "YES" "NO" "NS_DURING" "NS_HANDLER" "NS_ENDHANDLER")
+  idl	  '("TRUE" "FALSE")
+  pike	  '("UNDEFINED")) ;; Not a keyword, but practically works as one.
 
 (c-lang-defconst c-primary-expr-kwds
   "Keywords besides constants and operators that start primary expressions."
@@ -2381,7 +2391,7 @@ Note that Java specific rules are curren
 (c-lang-defconst c-opt-bitfield-key
   ;; Regexp matching the start of a bitfield (not uniquely), or nil in
   ;; languages without bitfield support.
-  t       nil
+  t	  nil
   (c c++) (c-make-keywords-re t (c-lang-const c-bitfield-kwds)))
 (c-lang-defvar c-opt-bitfield-key (c-lang-const c-opt-bitfield-key))
 
@@ -2458,10 +2468,10 @@ Note that Java specific rules are curren
   ;;
   ;; E.g. to see whether the string str contains a keyword on
   ;; `c-class-decl-kwds', one can do like this:
-  ;;     (get (intern-soft str c-keyword-obarray) 'c-class-decl-kwds)
+  ;;	 (get (intern-soft str c-keyword-obarray) 'c-class-decl-kwds)
   ;; Which preferably is written using the associated functions in
   ;; cc-engine:
-  ;;     (c-keyword-member (c-keyword-sym str) 'c-class-decl-kwds)
+  ;;	 (c-keyword-member (c-keyword-sym str) 'c-class-decl-kwds)
 
   ;; The obarray is not stored directly as a language constant since
   ;; the printed representation for obarrays used in .elc files isn't
@@ -2476,7 +2486,7 @@ Note that Java specific rules are curren
 	    alist (cdr alist))
       (setplist (intern kwd obarray)
 		;; Emacs has an odd bug that causes `mapcan' to fail
-		;; with unintelligible errors.  (XEmacs works.)
+		;; with unintelligible errors.	(XEmacs works.)
 		;;(mapcan (lambda (lang-const)
 		;;	      (list lang-const t))
 		;;	    lang-const-list)
@@ -2498,7 +2508,7 @@ Note that Java specific rules are curren
 
 (c-lang-defconst c-primary-expr-regexp
   ;; Regexp matching the start of any primary expression, i.e. any
-  ;; literal, symbol, prefix operator, and '('.  It doesn't need to
+  ;; literal, symbol, prefix operator, and '('.	 It doesn't need to
   ;; exclude keywords; they are excluded afterwards unless the second
   ;; submatch matches. If the first but not the second submatch
   ;; matches then it is an ambiguous primary expression; it could also
@@ -2560,7 +2570,7 @@ Note that Java specific rules are curren
        "\\.?[0-9]"
 
        "\\|"
-       ;; The unambiguous operators from `prefix-ops'.
+       ;; The nonambiguous operators from `prefix-ops'.
        (c-make-keywords-re nil
 	 (set-difference nonkeyword-prefix-ops in-or-postfix-ops
 			 :test 'string-equal))
@@ -2576,6 +2586,15 @@ Note that Java specific rules are curren
 
 ;;; Additional constants for parser-level constructs.
 
+(c-lang-defconst c-decl-start-colon-kwd-re
+  "Regexp matching a keyword that is followed by a colon, where
+  the whole construct can precede a declaration.
+  E.g. \"public:\" in C++."
+  t "\\<\\>"
+  c++ (c-make-keywords-re t (c-lang-const c-protection-kwds)))
+(c-lang-defvar c-decl-start-colon-kwd-re
+  (c-lang-const c-decl-start-colon-kwd-re))
+
 (c-lang-defconst c-decl-prefix-re
   "Regexp matching something that might precede a declaration, cast or
 label, such as the last token of a preceding statement or declaration.
@@ -2583,9 +2602,9 @@ This is used in the common situation whe
 doesn't start with any specific token that can be searched for.
 
 The regexp should not match bob; that is done implicitly.  It can't
-require a match longer than one token.  The end of the token is taken
+require a match longer than one token.	The end of the token is taken
 to be at the end of the first submatch, which is assumed to always
-match.  It's undefined whether identifier syntax (see
+match.	It's undefined whether identifier syntax (see
 `c-identifier-syntax-table') is in effect or not.  This regexp is
 assumed to be a superset of `c-label-prefix-re' if
 `c-recognize-colon-labels' is set.
@@ -2594,11 +2613,11 @@ Besides this, `c-decl-start-kwds' is use
 
 Note: This variable together with `c-decl-start-re' and
 `c-decl-start-kwds' is only used to detect \"likely\"
-declaration/cast/label starts.  I.e. they might produce more matches
+declaration/cast/label starts.	I.e. they might produce more matches
 but should not miss anything (or else it's necessary to use text
 properties - see the next note).  Wherever they match, the following
 construct is analyzed to see if it indeed is a declaration, cast or
-label.  That analysis is not cheap, so it's important that not too
+label.	That analysis is not cheap, so it's important that not too
 many false matches are triggered.
 
 Note: If a declaration/cast/label start can't be detected with this
@@ -2615,8 +2634,11 @@ more info."
   java "\\([\{\}\(;,<]+\\)"
   ;; Match "<" in C++ to get the first argument in a template arglist.
   ;; In that case there's an additional check in `c-find-decl-spots'
-  ;; that it got open paren syntax.
-  c++ "\\([\{\}\(\);,<]+\\)"
+  ;; that it got open paren syntax.  Match ":" to aid in picking up
+  ;; "public:", etc.  This involves additional checks in
+  ;; `c-find-decl-prefix-search' to prevent a match of identifiers
+  ;; or labels.
+  c++ "\\([\{\}\(\);:,<]+\\)"
   ;; Additionally match the protection directives in Objective-C.
   ;; Note that this doesn't cope with the longer directives, which we
   ;; would have to match from start to end since they don't end with
@@ -2686,7 +2708,7 @@ If parens can occur, the chars inside th
 list.
 
 '<' and '>' should be disallowed even if angle bracket arglists can
-occur.  That since the search function needs to stop at them anyway to
+occur.	That since the search function needs to stop at them anyway to
 ensure they are given paren syntax.
 
 This is used to skip backward from the open brace to find the region
@@ -2711,7 +2733,7 @@ possible for good performance."
 			       pos (match-end 0)))
 		       res))))
 
-  ;; Allow cpp operations (where applicable).
+  ;; Allow cpp operatios (where applicable).
   t (if (c-lang-const c-opt-cpp-prefix)
 	(set-difference (c-lang-const c-block-prefix-disallowed-chars)
 			'(?#))
@@ -2741,8 +2763,8 @@ possible for good performance."
 (c-lang-defvar c-block-prefix-charset (c-lang-const c-block-prefix-charset))
 
 (c-lang-defconst c-type-decl-prefix-key
-  "Regexp matching the declarator operators that might precede the
-identifier in a declaration, e.g. the \"*\" in \"char *argv\".  This
+  "Regexp matching any declarator operator that might precede the
+identifier in a declaration, e.g. the \"*\" in \"char *argv\".	This
 regexp should match \"(\" if parentheses are valid in declarators.
 The end of the first submatch is taken as the end of the operator.
 Identifier syntax is in effect when this is matched \(see
@@ -2779,7 +2801,7 @@ Identifier syntax is in effect when this
 
 (c-lang-defconst c-type-decl-suffix-key
   "Regexp matching the declarator operators that might follow after the
-identifier in a declaration, e.g. the \"[\" in \"char argv[]\".  This
+identifier in a declaration, e.g. the \"[\" in \"char argv[]\".	 This
 regexp should match \")\" if parentheses are valid in declarators.  If
 it matches an open paren of some kind, the type declaration check
 continues at the corresponding close paren, otherwise the end of the
@@ -2805,7 +2827,8 @@ is in effect when this is matched (see `
 		     "\\>")
 		  "")
 		"\\)")
-  (java idl) "\\([\[\(]\\)")
+  java "\\([\[\(\)]\\)"
+  idl "\\([\[\(]\\)")
 (c-lang-defvar c-type-decl-suffix-key (c-lang-const c-type-decl-suffix-key)
   'dont-doc)
 
@@ -2819,7 +2842,7 @@ undefined whether identifier syntax (see
 is in effect or not.
 
 Note that it's used in cases like after \"foo (bar)\" so it should
-only match when it's certain that it's a declaration, e.g., \"{\" but
+only match when it's certain that it's a declaration, e.g \"{\" but
 not \",\" or \";\"."
   t "{"
   ;; If K&R style declarations should be recognized then one could
@@ -2854,8 +2877,8 @@ not \",\" or \";\"."
 
 (c-lang-defconst c-opt-type-concat-key
   "Regexp matching operators that concatenate types, e.g. the \"|\" in
-\"int|string\" in Pike.  The end of the first submatch is taken as the
-end of the operator.  nil in languages without such operators.  It's
+\"int|string\" in Pike.	 The end of the first submatch is taken as the
+end of the operator.  nil in languages without such operators.	It's
 undefined whether identifier syntax (see `c-identifier-syntax-table')
 is in effect or not."
   t nil
@@ -2878,24 +2901,22 @@ is in effect or not."
 (c-lang-defvar c-known-type-key
   ;; Regexp matching the known type identifiers.  This is initialized
   ;; from the type keywords and `*-font-lock-extra-types'.  The first
-  ;; submatch is the one that matches the type.  Note that this regexp
+  ;; submatch is the one that matches the type.	 Note that this regexp
   ;; assumes that symbol constituents like '_' and '$' have word
   ;; syntax.
   (let* ((extra-types
 	  (when (boundp (c-mode-symbol "font-lock-extra-types"))
 	    (c-mode-var "font-lock-extra-types")))
 	 (regexp-strings
-	  (apply 'nconc
-		 (mapcar (lambda (re)
+	  (mapcan (lambda (re)
 		    (when (string-match "[][.*+?^$\\]" re)
 		      (list re)))
-		  extra-types)))
+		  extra-types))
 	 (plain-strings
-	  (apply 'nconc
-		 (mapcar (lambda (re)
+	  (mapcan (lambda (re)
 		    (unless (string-match "[][.*+?^$\\]" re)
 		      (list re)))
-		  extra-types))))
+		  extra-types)))
     (concat "\\<\\("
 	    (c-concat-separated
 	     (append (list (c-make-keywords-re nil
@@ -2926,19 +2947,21 @@ calls before a brace block.  This settin
 that are preceded by a declaration starting keyword, so
 e.g. `c-typeless-decl-kwds' may still be used when it's set to nil."
   t nil
-  (c c++ objc) t)
+  (c c++ objc java) t)
 (c-lang-defvar c-recognize-typeless-decls
   (c-lang-const c-recognize-typeless-decls))
 
 (c-lang-defconst c-recognize-<>-arglists
-  "Non-nil means C++ style template arglists should be handled.  More
+  "Non-nil means C++ style template arglists should be handled.	 More
 specifically, this means a comma separated list of types or
 expressions surrounded by \"<\" and \">\".  It's always preceded by an
 identifier or one of the keywords on `c-<>-type-kwds' or
 `c-<>-arglist-kwds'.  If there's an identifier before then the whole
 expression is considered to be a type."
   t (or (consp (c-lang-const c-<>-type-kwds))
-	(consp (c-lang-const c-<>-arglist-kwds))))
+	(consp (c-lang-const c-<>-arglist-kwds)))
+  java t)	    ; 2008-10-19.  This is crude.  The syntax for java
+		    ; generics is not yet coded in CC Mode.
 (c-lang-defvar c-recognize-<>-arglists (c-lang-const c-recognize-<>-arglists))
 
 (c-lang-defconst c-enums-contain-decls
@@ -2972,7 +2995,7 @@ i.e. compound statements surrounded by p
   ;; Regexp matching the start of angle bracket arglists in languages
   ;; where `c-recognize-<>-arglists' is set.  Does not exclude
   ;; keywords outside `c-<>-arglist-kwds'.  The first submatch is
-  ;; assumed to surround the preceding symbol.  The whole match is
+  ;; assumed to surround the preceding symbol.	The whole match is
   ;; assumed to end directly after the opening "<".
   t (if (c-lang-const c-recognize-<>-arglists)
 	(concat "\\("
@@ -3022,7 +3045,7 @@ not apply to labels recognized by `c-lab
 
 (c-lang-defconst c-label-prefix-re
   "Regexp like `c-decl-prefix-re' that matches any token that can precede
-a generic colon label.  Not used if `c-recognize-colon-labels' is
+a generic colon label.	Not used if `c-recognize-colon-labels' is
 nil."
   t "\\([{};]+\\)")
 (c-lang-defvar c-label-prefix-re
@@ -3085,7 +3108,7 @@ way."
 (c-lang-defvar c-opt-friend-key (c-lang-const c-opt-friend-key))
 
 (c-lang-defconst c-opt-method-key
-  ;; Special regexp to match the start of Objective-C methods.  The
+  ;; Special regexp to match the start of Objective-C methods.	The
   ;; first submatch is assumed to end after the + or - key.
   t    nil
   objc (concat
@@ -3117,7 +3140,7 @@ way."
 ;;; Wrap up the `c-lang-defvar' system.
 
 ;; Compile in the list of language variables that has been collected
-;; with the `c-lang-defvar' and `c-lang-setvar' macros.  Note that the
+;; with the `c-lang-defvar' and `c-lang-setvar' macros.	 Note that the
 ;; first element of each is nil.
 (defconst c-lang-variable-inits (cc-eval-when-compile c-lang-variable-inits))
 (defconst c-emacs-variable-inits (cc-eval-when-compile c-emacs-variable-inits))
@@ -3237,4 +3260,7 @@ evaluated and should not be quoted."
 
 (cc-provide 'cc-langs)
 
+;;; arch-tag: 1ab57482-cfc2-4c5b-b628-3539c3098822
+
 ;;; cc-langs.el ends here
+
--- /dev/null
+++ emacs24-24.3+1/lisp/progmodes/cc-lobotomy.el
@@ -0,0 +1,160 @@
+;;; cc-lobotomy.el --- excise portions of cc-mode's brain... for speed
+
+;; Copyright (C) 1985,1987,1992-2003, 2005, 2006, 2007, 2008, 2009,
+;;   2010, 2011  Free Software Foundation, Inc.
+
+;; Author:     1995 Barry A. Warsaw
+;; Maintainer: Unmaintained
+;; Created:    March 1995, split from cc-mode.el
+;; Version:    See cc-mode.el
+;; Keywords:   c languages oop
+
+;; This file is not part of GNU Emacs.
+
+;; This program is free software; you can redistribute it and/or modify
+;; it under the terms of the GNU General Public License as published by
+;; the Free Software Foundation; either version 3 of the License, or
+;; (at your option) any later version.
+
+;; This program is distributed in the hope that it will be useful,
+;; but WITHOUT ANY WARRANTY; without even the implied warranty of
+;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
+;; GNU General Public License for more details.
+
+;; You should have received a copy of the GNU General Public License
+;; along with this program; see the file COPYING.  If not, see
+;; <http://www.gnu.org/licenses/>.
+
+;;; Commentary:
+;;
+;; Every effort has been made to improve the performance of
+;; cc-mode. However, due to the nature of the C, C++, and Objective-C
+;; language definitions, a trade-off is often required between
+;; accuracy of construct recognition and speed. I believe it is always
+;; best to be correct, and that the mode is currently fast enough for
+;; most normal usage.  Others disagree.	 I have no intention of
+;; including these hacks in the main distribution.  When cc-mode
+;; version 5 comes out, it will include a rewritten indentation engine
+;; so that performance will be greatly improved automatically.	This
+;; was not included in this release of version 4 so that Emacs 18
+;; could still be supported.  Note that this implies that cc-mode
+;; version 5 will *not* work on Emacs 18!
+;;
+;; To use, see the variable cc-lobotomy-pith-list and the function
+;; cc-lobotomize.   The variable contains a good explanation of the
+;; speed/accuracy trade-offs for each option.  Set it to what you'd
+;; like, and call cc-lobotomy in your c-mode-hook.
+;;
+;; This will redefine certain cc-mode functions and affect all cc-mode
+;; buffers globally.
+;;
+;; This file is completely unsupported!	 Although it has been patched
+;; superficially to keep pace with the rest of CC Mode, it hasn't been
+;; tested for a long time.
+
+;;; Code:
+
+(eval-when-compile
+  (let ((load-path
+	 (if (and (boundp 'byte-compile-dest-file)
+		  (stringp byte-compile-dest-file))
+	     (cons (file-name-directory byte-compile-dest-file) load-path)
+	   load-path)))
+    (load "cc-bytecomp" nil t)))
+
+(cc-require 'cc-defs)
+(cc-require 'cc-engine)
+(cc-require 'cc-cmds)
+
+
+(defvar cc-lobotomy-pith-list ()
+  "*List of things to dumb-ify to speed up cc-mode.  Note that each
+incurs a penalty in correct identification of certain code constructs.
+Possible values to put on this list:
+
+  'literal -- `c-in-literal' is lobotomized.  This will significantly
+	      speed up parsing over large lists of cpp macros, as seen
+	      for instance in header files.  The penalty is that you
+	      cannot put the `#' character as the first non-whitespace
+	      character on a line inside other multi-line literals
+	      (i.e. comments or strings)
+
+  'class   -- `c-narrow-out-enclosing-class' and `c-search-uplist for
+	      classkey' are lobotomized.  This speeds up some
+	      indenting inside and around class and struct
+	      definitions.  The penalty is that elements inside of
+	      classes and structs may not indent correctly.
+
+  'lists   -- `c-inside-bracelist-p' is lobotomized.  This speeds up
+	      indenting inside and around brace lists (e.g. aggregate
+	      initializers, enum lists, etc.).	The penalty is that
+	      elements inside these lists may not indent correctly.")
+
+(defun cc-lobotomize ()
+  "Perform lobotomies on cc-mode as described in `cc-lobotomy-pith-list'."
+  (let (pithedp)
+    (if (memq 'literal cc-lobotomy-pith-list)
+	(progn
+	  (fset 'c-in-literal 'cc-in-literal-lobotomized)
+	  (setq pithedp t)))
+    (if (memq 'class cc-lobotomy-pith-list)
+	(progn
+	  (fset 'c-narrow-out-enclosing-class
+		'cc-narrow-out-enclosing-class-lobotomized)
+	  (fset 'c-search-uplist-for-classkey
+		'cc-search-uplist-for-classkey-lobotomized)
+	  (setq pithedp t)))
+    (if (memq 'lists cc-lobotomy-pith-list)
+	(progn
+	  (fset 'c-inside-bracelist-p 'cc-inside-bracelist-p-lobotomized)
+	  (setq pithedp t)))
+    (if pithedp
+	(add-hook 'c-prepare-bug-report-hooks 'cc-lobo-bug-report-blurb))
+    ))
+
+
+;; This is a faster version of c-in-literal.  It trades speed for one
+;; approximation, namely that within other literals, the `#' character
+;; cannot be the first non-whitespace on a line.  This only happens if
+;; detect-cpp is non-nil, which isn't very often.
+(defun cc-in-literal-lobotomized (&optional lim detect-cpp)
+  ;; first check the cache
+  (if (and (vectorp c-in-literal-cache)
+	   (= (point) (aref c-in-literal-cache 0)))
+      (aref c-in-literal-cache 1)
+    ;; quickly check for cpp macro. this breaks if the `#' character
+    ;; appears as the first non-whitespace on a line inside another
+    ;; literal.
+    (let* (state
+	   (char-at-boi (char-after (c-point 'boi)))
+	   (rtn (cond
+		 ((and detect-cpp char-at-boi (= char-at-boi ?#))
+		  'pound)
+		 ((nth 3 (setq state (save-excursion
+				       (parse-partial-sexp
+					(or lim (c-point 'bod))
+					(point)))))
+		  'string)
+		 ((nth 4 state) (if (nth 7 state) 'c++ 'c))
+		 (t nil))))
+      ;; cache this result if the cache is enabled
+      (if (not c-in-literal-cache)
+	  (setq c-in-literal-cache (vector (point) rtn)))
+      rtn)))
+
+(defun cc-narrow-out-enclosing-class-lobotomized (dummy1 dummy2) nil)
+
+(defun cc-search-uplist-for-classkey-lobotomized (dummy) nil)
+
+(defun cc-inside-bracelist-p-lobotomized (dummy1 dummy2) nil)
+
+(defun cc-lobo-bug-report-blurb ()
+  (insert
+   "\nYou are using cc-lobotomy.el.  You realize that by doing\n"
+   "so you have already made the decision to trade off accuracy\n"
+   "for speed?	Don't set your hopes too high that your problem\n"
+   "will be fixed.\n\n"))
+
+
+(cc-provide 'cc-lobotomy)
+;;; cc-lobotomy.el ends here
